//----------------------------------------------------------------------
// Tv      : videoInputCupLv`Tv
// File Name : Main.cpp
// Library   : OpenCV for MS-Windows 1.0 / videoInput Library 0.195
// Auther    : dandelion
// Date      : Oct 22, 2007; 20:00
//----------------------------------------------------------------------

#include <iostream>
#include <cstdlib>

//wb_CN[h(OpenCV֘A)
#include <cv.h>
#include <cxcore.h>
#include <highgui.h>

//wb_CN[h(videoInput Library֘A)
#include "videoInput.h"

using namespace std;

//Cuǂݍ(OpenCV֘A)
#pragma comment(lib,"cv.lib")
#pragma comment(lib,"cxcore.lib")
#pragma comment(lib,"highgui.lib")

// Cuǂݍ(videoInput Library֘A)
#pragma comment(lib,"videoInput.lib")

//萔
#define CAPTURE_WIDTH	320	//Lv`TCY()
#define CAPTURE_HEIGHT  240	//Lv`TCY()

int main(void)
{
	int device1 = 0;
	int key = 0;

	//Lv`摜
	IplImage *image = cvCreateImage(cvSize(CAPTURE_WIDTH, CAPTURE_HEIGHT), IPL_DEPTH_8U, 3);

	//EBhE
	char* window_name = "Capture using videoInput Library";
	cvNamedWindow(window_name,  CV_WINDOW_AUTOSIZE);

	//videoInputIuWFNg
	videoInput VI;

	//p\ȃLv`foCX擾
	int numDevices = VI.listDevices();

	//Lv`foCXȂI
	if(numDevices == 0)
	{
		cerr << "[Error] Capture device not found!!" << endl;
		exit(0);
	}

	//foCXi̓foCXID = 0CCAPTURE_WIDTH x CAPTURE_HEIGHTŃLv`j
	VI.setupDevice(device1, CAPTURE_WIDTH, CAPTURE_HEIGHT);

	//ESCL[܂ŃLv`𑱂
	while(key != 0x1b)
	{
		//getPixels2Ԗڂ̈
		//true:RGB̉摜
		//false:BGR̉摜
		image->imageData = (char *)VI.getPixels(device1, false); //getPixelsœ摜unsigned char^C
																			//OpenCVIplImagechar^Ȃ̂ŃLXgĂ
		//摜\
		cvShowImage(window_name, image);

		//L[
		key = cvWaitKey(1);
	}

	//㏈
	VI.stopDevice(device1);
	cvDestroyWindow(window_name);
	cvReleaseImage(&image);

	return 0;
}